do
local originalCreateUI = CreateUI
local originalOnSelectionChanged = OnSelectionChanged
local originalOnBeat = OnBeat


function CreateUI(isReplay)
    originalCreateUI(isReplay)
	import("/mods/advancedgrouping/groupinterface.lua").Init()
end


local selectionChange = false
local wasSquad = false
local oldSquad = false

function OnSelectionChanged(oldSelection, newSelection, added, removed)
	--only check squad selection code if there is a change in selection and auto squad selection is enabled
	if not table.equal(newSelection, oldSelection) and import("/mods/advancedgrouping/groupinterface.lua").AutoSelection then
		selectionChange = true
		--if there was an old selection then check if that old selection was a single, fully selected squad
		--leaves variables wasSquad (true if old selection was a single squad) and oldSquad (the number of the squad)
		--wasSquad is reset to false every beat to allow deselect then reselect a unit to select full squad.
		if table.getn(oldSelection) > 0 then
			oldSquad = oldSelection[1].Squad
			wasSquad = true
			for i, oldUnit in oldSelection do
				if oldUnit.Squad == nil or oldUnit.Squad != oldSquad then
					wasSquad = false
				end
			end
		end
		--check if every unit in the new selection is a part of the old squad, if so then don't run the squad auto selection code
		if wasSquad then
			local subset = true
			for i, newUnit in newSelection do
				if newUnit.Squad == nil or newUnit.Squad != oldSquad then
					subset = false
				end
			end
			if subset then
				selectionChange = false
			end
		end
	end
	--run old selection code
    originalOnSelectionChanged(oldSelection, newSelection, added, removed)
end

function OnBeat()
	if selectionChange then
		import("/mods/advancedgrouping/selectionsplit.lua").GroupChecker()
		selectionChange = false
	end
	wasSquad = false
	originalOnBeat()
end

end
