splitselectionSets = {}
local numunits = 0
local CurrentSelection
local currentsquad = 1
local squadSets = {}
local tempselector = {}
local tempindex = 1



--called from gamemain, to split a selection into subgroups
function SelectionSplitter(type)
	AddSplitSelectionSet(type, GetSelectedUnits())
end

function AddSplitSelectionSet(totalSets, unitArray)
    -- remove units from the selection set if it already exists
	for name in splitselectionSets do
	    if splitselectionSets[name] then
			for index, unit in splitselectionSets[name] do
				unit:RemoveSelectionSet(name)
			end
		end
    end
	splitselectionSets = {alt1 = {},
		alt2 = {},
		alt3 = {},
		alt4 = {},
		alt5 = {},
		alt6 = {},
		alt7 = {},
		alt8 = {},
		alt9 = {},
		alt0 = {},
	}
    splitselectionSets["temp"] = unitArray

	if splitselectionSets["temp"] then
		table.sort(splitselectionSets["temp"], 
			function(unit1, unit2)
				bpid1 = unit1:GetBlueprint().BlueprintId
				bpid2 = unit2:GetBlueprint().BlueprintId
				return bpid1<bpid2
			end)
		local index = 1
		for i, unit in splitselectionSets["temp"] do
			unit:AddSelectionSet("alt"..index)
			table.insert(splitselectionSets["alt"..index], unit)
			if index < totalSets then
				index = index + 1
			else
				index = 1
			end
		end
	end
end

--select the subgroups
function SplitSelector(name)
	SelectUnits(splitselectionSets[name])
end

--put the current selected units into a squad
function SquadCreator()
	squadSets[currentsquad] = GetSelectedUnits()
	if squadSets[currentsquad] then
		--assign a tag to the unit saying what squad it's in and what position in that squad, if it's already in a squad remove it from the old one
		for i, unit in squadSets[currentsquad] do
			if unit.Squad and squadSets[unit.Squad] then
				squadSets[unit.Squad][unit.Squadindex] = nil
			end
			unit.Squad = currentsquad
			unit.Squadindex = i
		end
		currentsquad = currentsquad + 1
		--remove dead units from squads, remove empty squads from the squadset
		for i, squad in squadSets do
			for i2, unit in squad do
				if unit:IsDead() then
					squadSets[unit.Squad][unit.Squadindex] = nil
				end			
			end
			if table.getsize(squad) == 0 then
				squadSets[i] = nil
			end		
		end
	end
end

--disband the squad
function Disband()
	local selection = GetSelectedUnits()
	if selection then
		for i, unit in selection do
			if unit.Squad then
				squadSets[unit.Squad] = nil
			end
		end
	end
end

--debug function, lists all current squads
function SquadCheck()
	LOG(repr(squadSets))
end

--checks if the current selection contains units in a squad, then selects those squads
function GroupChecker()
	local unitsInSquads = {}
	CurrentSelection = GetSelectedUnits()
	--if current selection exists and at least 1 squad exists then check if any units in the selection are in a squad
	if CurrentSelection and table.getsize(squadSets) > 0 then
		tempselector = GetSelectedUnits()
		tempindex = table.getsize(tempselector) + 1
		--make a table of all units in squads from the selection
		for i, unit in tempselector do
			if unit.Squad then
				if not unitsInSquads[unit.Squad] then
					unitsInSquads[unit.Squad] = {unit.Squadindex}
				else
					table.insert(unitsInSquads[unit.Squad], unit.Squadindex)
				end
			end
		end
		--from that table, add any partially selected squads to tempselector
		for squad, squadunit in unitsInSquads do
			if squadSets[squad] then
				for i, unit in squadSets[squad] do
					if unit then
						--cleaning up
						if unit:IsDead() then
							squadSets[squad][unit.Squadindex] = nil
						--only add if the unit isn't already in the selection
						elseif not table.find(squadunit, unit.Squadindex) then
							tempselector[tempindex] = unit
							tempindex = tempindex + 1
						end
					end
				end
			end
		end
		--if we've selected new units, then update the selection
		if not table.equal(CurrentSelection, tempselector) then
			SelectUnits(tempselector)
		end
	end
end
